/* Utils.c generated by valac 0.38.10, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * Copyright (c) 2011-2015 elementary LLC. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define POWER_SERVICES_TYPE_DEVICE (power_services_device_get_type ())
#define POWER_SERVICES_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_SERVICES_TYPE_DEVICE, PowerServicesDevice))
#define POWER_SERVICES_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POWER_SERVICES_TYPE_DEVICE, PowerServicesDeviceClass))
#define POWER_SERVICES_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_SERVICES_TYPE_DEVICE))
#define POWER_SERVICES_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POWER_SERVICES_TYPE_DEVICE))
#define POWER_SERVICES_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POWER_SERVICES_TYPE_DEVICE, PowerServicesDeviceClass))

typedef struct _PowerServicesDevice PowerServicesDevice;
typedef struct _PowerServicesDeviceClass PowerServicesDeviceClass;
#define _g_free0(var) (var = (g_free (var), NULL))



gboolean power_utils_type_is_battery (guint32 device_type);
#define DEVICE_TYPE_UNKNOWN ((guint32) 0)
#define DEVICE_TYPE_LINE_POWER ((guint32) 1)
gboolean power_utils_type_has_device_icon (guint32 device_type);
#define DEVICE_TYPE_PHONE ((guint32) 8)
#define DEVICE_TYPE_MOUSE ((guint32) 5)
#define DEVICE_TYPE_KEYBOARD ((guint32) 6)
#define DEVICE_TYPE_TABLET ((guint32) 10)
GType power_services_device_get_type (void) G_GNUC_CONST;
gchar* power_utils_get_symbolic_icon_name_for_battery (PowerServicesDevice* battery);
gchar* power_utils_get_icon_name_for_battery (PowerServicesDevice* battery);
gdouble power_services_device_get_percentage (PowerServicesDevice* self);
gboolean power_utils_is_charging (guint32 state);
guint32 power_services_device_get_state (PowerServicesDevice* self);
const gchar* power_utils_get_battery_icon (gdouble percentage, gint64 remaining_time);
gint64 power_services_device_get_time_to_empty (PowerServicesDevice* self);
gchar* power_utils_get_icon_name_for_device (PowerServicesDevice* device);
guint32 power_services_device_get_device_type (PowerServicesDevice* self);
#define DEVICE_STATE_FULLY_CHARGED ((guint32) 4)
#define DEVICE_STATE_CHARGING ((guint32) 1)
gchar* power_utils_get_title_for_battery (PowerServicesDevice* battery);
#define DEVICE_TYPE_BATTERY ((guint32) 2)
#define DEVICE_TYPE_UPS ((guint32) 3)
#define DEVICE_TYPE_MONITOR ((guint32) 4)
#define DEVICE_TYPE_PDA ((guint32) 7)
#define DEVICE_TYPE_MEDIA_PLAYER ((guint32) 9)
#define DEVICE_TYPE_COMPUTER ((guint32) 11)
const gchar* power_services_device_get_vendor (PowerServicesDevice* self);
const gchar* power_services_device_get_model (PowerServicesDevice* self);
gchar* power_utils_get_info_for_battery (PowerServicesDevice* battery);
gint64 power_services_device_get_time_to_full (PowerServicesDevice* self);
#define CONSTANTS_GETTEXT_PACKAGE "power-indicator"
void power_utils_translations (void);


gboolean power_utils_type_is_battery (guint32 device_type) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	guint32 _tmp1_;
	_tmp1_ = device_type;
	if (_tmp1_ != DEVICE_TYPE_UNKNOWN) {
		guint32 _tmp2_;
		_tmp2_ = device_type;
		_tmp0_ = _tmp2_ != DEVICE_TYPE_LINE_POWER;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gboolean power_utils_type_has_device_icon (guint32 device_type) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	guint32 _tmp3_;
	_tmp3_ = device_type;
	if (_tmp3_ == DEVICE_TYPE_PHONE) {
		_tmp2_ = TRUE;
	} else {
		guint32 _tmp4_;
		_tmp4_ = device_type;
		_tmp2_ = _tmp4_ == DEVICE_TYPE_MOUSE;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		guint32 _tmp5_;
		_tmp5_ = device_type;
		_tmp1_ = _tmp5_ == DEVICE_TYPE_KEYBOARD;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		guint32 _tmp6_;
		_tmp6_ = device_type;
		_tmp0_ = _tmp6_ == DEVICE_TYPE_TABLET;
	}
	result = _tmp0_;
	return result;
}


gchar* power_utils_get_symbolic_icon_name_for_battery (PowerServicesDevice* battery) {
	gchar* result = NULL;
	PowerServicesDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_val_if_fail (battery != NULL, NULL);
	_tmp0_ = battery;
	_tmp1_ = power_utils_get_icon_name_for_battery (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, "-symbolic", NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


gchar* power_utils_get_icon_name_for_battery (PowerServicesDevice* battery) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	PowerServicesDevice* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	g_return_val_if_fail (battery != NULL, NULL);
	_tmp1_ = battery;
	_tmp2_ = power_services_device_get_percentage (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == ((gdouble) 100)) {
		PowerServicesDevice* _tmp4_;
		guint32 _tmp5_;
		guint32 _tmp6_;
		gboolean _tmp7_;
		_tmp4_ = battery;
		_tmp5_ = power_services_device_get_state (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = power_utils_is_charging (_tmp6_);
		_tmp0_ = _tmp7_ == TRUE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* _tmp8_;
		_tmp8_ = g_strdup ("battery-full-charged");
		result = _tmp8_;
		return result;
	} else {
		const gchar* _tmp9_ = NULL;
		PowerServicesDevice* _tmp10_;
		guint32 _tmp11_;
		guint32 _tmp12_;
		gboolean _tmp13_;
		PowerServicesDevice* _tmp14_;
		gdouble _tmp15_;
		gdouble _tmp16_;
		PowerServicesDevice* _tmp17_;
		gint64 _tmp18_;
		gint64 _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		_tmp10_ = battery;
		_tmp11_ = power_services_device_get_state (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = power_utils_is_charging (_tmp12_);
		if (_tmp13_) {
			_tmp9_ = "-charging";
		} else {
			_tmp9_ = "";
		}
		_tmp14_ = battery;
		_tmp15_ = power_services_device_get_percentage (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = battery;
		_tmp18_ = power_services_device_get_time_to_empty (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = power_utils_get_battery_icon (_tmp16_, _tmp19_);
		_tmp21_ = g_strconcat (_tmp20_, _tmp9_, NULL);
		result = _tmp21_;
		return result;
	}
}


gchar* power_utils_get_icon_name_for_device (PowerServicesDevice* device) {
	gchar* result = NULL;
	PowerServicesDevice* _tmp0_;
	guint32 _tmp1_;
	guint32 _tmp2_;
	g_return_val_if_fail (device != NULL, NULL);
	_tmp0_ = device;
	_tmp1_ = power_services_device_get_device_type (_tmp0_);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case DEVICE_TYPE_PHONE:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("phone");
			result = _tmp3_;
			return result;
		}
		case DEVICE_TYPE_MOUSE:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("input-mouse");
			result = _tmp4_;
			return result;
		}
		case DEVICE_TYPE_KEYBOARD:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("input-keyboard");
			result = _tmp5_;
			return result;
		}
		case DEVICE_TYPE_TABLET:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("input-tablet");
			result = _tmp6_;
			return result;
		}
		default:
		{
			PowerServicesDevice* _tmp7_;
			gchar* _tmp8_;
			_tmp7_ = device;
			_tmp8_ = power_utils_get_icon_name_for_battery (_tmp7_);
			result = _tmp8_;
			return result;
		}
	}
}


const gchar* power_utils_get_battery_icon (gdouble percentage, gint64 remaining_time) {
	const gchar* result = NULL;
	gdouble _tmp0_;
	gboolean _tmp1_ = FALSE;
	gdouble _tmp2_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	_tmp0_ = percentage;
	if (_tmp0_ <= ((gdouble) 0)) {
		result = "battery-good";
		return result;
	}
	_tmp2_ = percentage;
	if (_tmp2_ < ((gdouble) 10)) {
		gboolean _tmp3_ = FALSE;
		gint64 _tmp4_;
		_tmp4_ = remaining_time;
		if (_tmp4_ == ((gint64) 0)) {
			_tmp3_ = TRUE;
		} else {
			gint64 _tmp5_;
			_tmp5_ = remaining_time;
			_tmp3_ = _tmp5_ < ((gint64) (30 * 60));
		}
		_tmp1_ = _tmp3_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		result = "battery-empty";
		return result;
	}
	_tmp6_ = percentage;
	if (_tmp6_ < ((gdouble) 30)) {
		result = "battery-caution";
		return result;
	}
	_tmp7_ = percentage;
	if (_tmp7_ < ((gdouble) 60)) {
		result = "battery-low";
		return result;
	}
	_tmp8_ = percentage;
	if (_tmp8_ < ((gdouble) 80)) {
		result = "battery-good";
		return result;
	}
	result = "battery-full";
	return result;
}


gboolean power_utils_is_charging (guint32 state) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	guint32 _tmp1_;
	_tmp1_ = state;
	if (_tmp1_ == DEVICE_STATE_FULLY_CHARGED) {
		_tmp0_ = TRUE;
	} else {
		guint32 _tmp2_;
		_tmp2_ = state;
		_tmp0_ = _tmp2_ == DEVICE_STATE_CHARGING;
	}
	result = _tmp0_;
	return result;
}


gchar* power_utils_get_title_for_battery (PowerServicesDevice* battery) {
	gchar* result = NULL;
	gchar* title = NULL;
	gchar* _tmp0_;
	PowerServicesDevice* _tmp1_;
	guint32 _tmp2_;
	guint32 _tmp3_;
	gboolean _tmp20_ = FALSE;
	PowerServicesDevice* _tmp21_;
	guint32 _tmp22_;
	guint32 _tmp23_;
	gboolean _tmp31_ = FALSE;
	PowerServicesDevice* _tmp32_;
	guint32 _tmp33_;
	guint32 _tmp34_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	g_return_val_if_fail (battery != NULL, NULL);
	_tmp0_ = g_strdup ("");
	title = _tmp0_;
	_tmp1_ = battery;
	_tmp2_ = power_services_device_get_device_type (_tmp1_);
	_tmp3_ = _tmp2_;
	switch (_tmp3_) {
		case DEVICE_TYPE_BATTERY:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Battery"));
			_g_free0 (title);
			title = _tmp4_;
			break;
		}
		case DEVICE_TYPE_UPS:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("UPS"));
			_g_free0 (title);
			title = _tmp5_;
			break;
		}
		case DEVICE_TYPE_MONITOR:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Display"));
			_g_free0 (title);
			title = _tmp6_;
			break;
		}
		case DEVICE_TYPE_MOUSE:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("Mouse"));
			_g_free0 (title);
			title = _tmp7_;
			break;
		}
		case DEVICE_TYPE_KEYBOARD:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup (_ ("Keyboard"));
			_g_free0 (title);
			title = _tmp8_;
			break;
		}
		case DEVICE_TYPE_PDA:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup (_ ("PDA"));
			_g_free0 (title);
			title = _tmp9_;
			break;
		}
		case DEVICE_TYPE_PHONE:
		{
			gchar* _tmp10_;
			_tmp10_ = g_strdup (_ ("Phone"));
			_g_free0 (title);
			title = _tmp10_;
			break;
		}
		case DEVICE_TYPE_MEDIA_PLAYER:
		{
			gchar* _tmp11_;
			_tmp11_ = g_strdup (_ ("Media Player"));
			_g_free0 (title);
			title = _tmp11_;
			break;
		}
		case DEVICE_TYPE_TABLET:
		{
			gchar* _tmp12_;
			_tmp12_ = g_strdup (_ ("Tablet"));
			_g_free0 (title);
			title = _tmp12_;
			break;
		}
		case DEVICE_TYPE_COMPUTER:
		{
			gchar* _tmp13_;
			_tmp13_ = g_strdup (_ ("Computer"));
			_g_free0 (title);
			title = _tmp13_;
			break;
		}
		default:
		{
			PowerServicesDevice* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			_tmp14_ = battery;
			_tmp15_ = power_services_device_get_vendor (_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = g_strconcat (_tmp16_, " ", NULL);
			_tmp18_ = _tmp17_;
			_tmp19_ = g_strconcat (_tmp18_, _ ("Device"), NULL);
			_g_free0 (title);
			title = _tmp19_;
			_g_free0 (_tmp18_);
			break;
		}
	}
	_tmp21_ = battery;
	_tmp22_ = power_services_device_get_device_type (_tmp21_);
	_tmp23_ = _tmp22_;
	if (_tmp23_ == DEVICE_TYPE_PHONE) {
		PowerServicesDevice* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		_tmp24_ = battery;
		_tmp25_ = power_services_device_get_model (_tmp24_);
		_tmp26_ = _tmp25_;
		_tmp20_ = g_strcmp0 (_tmp26_, "") != 0;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		PowerServicesDevice* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
		_tmp27_ = battery;
		_tmp28_ = power_services_device_get_model (_tmp27_);
		_tmp29_ = _tmp28_;
		_tmp30_ = g_strdup (_tmp29_);
		_g_free0 (title);
		title = _tmp30_;
	}
	_tmp32_ = battery;
	_tmp33_ = power_services_device_get_device_type (_tmp32_);
	_tmp34_ = _tmp33_;
	if (_tmp34_ == DEVICE_TYPE_TABLET) {
		PowerServicesDevice* _tmp35_;
		const gchar* _tmp36_;
		const gchar* _tmp37_;
		_tmp35_ = battery;
		_tmp36_ = power_services_device_get_model (_tmp35_);
		_tmp37_ = _tmp36_;
		_tmp31_ = g_strcmp0 (_tmp37_, "") != 0;
	} else {
		_tmp31_ = FALSE;
	}
	if (_tmp31_) {
		PowerServicesDevice* _tmp38_;
		const gchar* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		_tmp38_ = battery;
		_tmp39_ = power_services_device_get_model (_tmp38_);
		_tmp40_ = _tmp39_;
		_tmp41_ = g_strdup (_tmp40_);
		_g_free0 (title);
		title = _tmp41_;
	}
	_tmp42_ = title;
	_tmp43_ = g_strdup_printf ("<b>%s</b>", _tmp42_);
	result = _tmp43_;
	_g_free0 (title);
	return result;
}


gchar* power_utils_get_info_for_battery (PowerServicesDevice* battery) {
	gchar* result = NULL;
	gint percent = 0;
	PowerServicesDevice* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gboolean charging = FALSE;
	PowerServicesDevice* _tmp4_;
	guint32 _tmp5_;
	guint32 _tmp6_;
	gboolean _tmp7_;
	gint _tmp8_;
	gchar* info = NULL;
	gchar* _tmp10_;
	gboolean _tmp11_;
	g_return_val_if_fail (battery != NULL, NULL);
	_tmp0_ = battery;
	_tmp1_ = power_services_device_get_percentage (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = round (_tmp2_);
	percent = (gint) _tmp3_;
	_tmp4_ = battery;
	_tmp5_ = power_services_device_get_state (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = power_utils_is_charging (_tmp6_);
	charging = _tmp7_;
	_tmp8_ = percent;
	if (_tmp8_ <= 0) {
		gchar* _tmp9_;
		_tmp9_ = g_strdup (_ ("Calculating…"));
		result = _tmp9_;
		return result;
	}
	_tmp10_ = g_strdup ("");
	info = _tmp10_;
	_tmp11_ = charging;
	if (_tmp11_) {
		const gchar* _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gint64 seconds = 0LL;
		PowerServicesDevice* _tmp17_;
		gint64 _tmp18_;
		gint64 _tmp19_;
		gint64 _tmp20_;
		_tmp12_ = info;
		_tmp13_ = percent;
		_tmp14_ = g_strdup_printf (_ ("%i%% charged"), _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
		_g_free0 (info);
		info = _tmp16_;
		_g_free0 (_tmp15_);
		_tmp17_ = battery;
		_tmp18_ = power_services_device_get_time_to_full (_tmp17_);
		_tmp19_ = _tmp18_;
		seconds = _tmp19_;
		_tmp20_ = seconds;
		if (_tmp20_ > ((gint64) 0)) {
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gint64 _tmp23_;
			_tmp21_ = info;
			_tmp22_ = g_strconcat (_tmp21_, " - ", NULL);
			_g_free0 (info);
			info = _tmp22_;
			_tmp23_ = seconds;
			if (_tmp23_ >= ((gint64) 86400)) {
				gint64 days = 0LL;
				gint64 _tmp24_;
				const gchar* _tmp25_;
				gint64 _tmp26_;
				gint64 _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				_tmp24_ = seconds;
				days = _tmp24_ / 86400;
				_tmp25_ = info;
				_tmp26_ = days;
				_tmp27_ = days;
				_tmp28_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld day until full", "%lld days until full", (gulong) _tmp26_), _tmp27_);
				_tmp29_ = _tmp28_;
				_tmp30_ = g_strconcat (_tmp25_, _tmp29_, NULL);
				_g_free0 (info);
				info = _tmp30_;
				_g_free0 (_tmp29_);
			} else {
				gint64 _tmp31_;
				_tmp31_ = seconds;
				if (_tmp31_ >= ((gint64) 3600)) {
					gint64 hours = 0LL;
					gint64 _tmp32_;
					const gchar* _tmp33_;
					gint64 _tmp34_;
					gint64 _tmp35_;
					gchar* _tmp36_;
					gchar* _tmp37_;
					gchar* _tmp38_;
					_tmp32_ = seconds;
					hours = _tmp32_ / 3600;
					_tmp33_ = info;
					_tmp34_ = hours;
					_tmp35_ = hours;
					_tmp36_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld hour until full", "%lld hours until full", (gulong) _tmp34_), _tmp35_);
					_tmp37_ = _tmp36_;
					_tmp38_ = g_strconcat (_tmp33_, _tmp37_, NULL);
					_g_free0 (info);
					info = _tmp38_;
					_g_free0 (_tmp37_);
				} else {
					gint64 _tmp39_;
					_tmp39_ = seconds;
					if (_tmp39_ >= ((gint64) 60)) {
						gint64 minutes = 0LL;
						gint64 _tmp40_;
						const gchar* _tmp41_;
						gint64 _tmp42_;
						gint64 _tmp43_;
						gchar* _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
						_tmp40_ = seconds;
						minutes = _tmp40_ / 60;
						_tmp41_ = info;
						_tmp42_ = minutes;
						_tmp43_ = minutes;
						_tmp44_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld minute until full", "%lld minutes until full", (gulong) _tmp42_), _tmp43_);
						_tmp45_ = _tmp44_;
						_tmp46_ = g_strconcat (_tmp41_, _tmp45_, NULL);
						_g_free0 (info);
						info = _tmp46_;
						_g_free0 (_tmp45_);
					} else {
						const gchar* _tmp47_;
						gint64 _tmp48_;
						gint64 _tmp49_;
						gchar* _tmp50_;
						gchar* _tmp51_;
						gchar* _tmp52_;
						_tmp47_ = info;
						_tmp48_ = seconds;
						_tmp49_ = seconds;
						_tmp50_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld second until full", "%lld seconds until full", (gulong) _tmp48_), _tmp49_);
						_tmp51_ = _tmp50_;
						_tmp52_ = g_strconcat (_tmp47_, _tmp51_, NULL);
						_g_free0 (info);
						info = _tmp52_;
						_g_free0 (_tmp51_);
					}
				}
			}
		}
	} else {
		const gchar* _tmp53_;
		gint _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		gint64 seconds = 0LL;
		PowerServicesDevice* _tmp58_;
		gint64 _tmp59_;
		gint64 _tmp60_;
		gint64 _tmp61_;
		_tmp53_ = info;
		_tmp54_ = percent;
		_tmp55_ = g_strdup_printf (_ ("%i%% remaining"), _tmp54_);
		_tmp56_ = _tmp55_;
		_tmp57_ = g_strconcat (_tmp53_, _tmp56_, NULL);
		_g_free0 (info);
		info = _tmp57_;
		_g_free0 (_tmp56_);
		_tmp58_ = battery;
		_tmp59_ = power_services_device_get_time_to_empty (_tmp58_);
		_tmp60_ = _tmp59_;
		seconds = _tmp60_;
		_tmp61_ = seconds;
		if (_tmp61_ > ((gint64) 0)) {
			const gchar* _tmp62_;
			gchar* _tmp63_;
			gint64 _tmp64_;
			_tmp62_ = info;
			_tmp63_ = g_strconcat (_tmp62_, " - ", NULL);
			_g_free0 (info);
			info = _tmp63_;
			_tmp64_ = seconds;
			if (_tmp64_ >= ((gint64) 86400)) {
				gint64 days = 0LL;
				gint64 _tmp65_;
				const gchar* _tmp66_;
				gint64 _tmp67_;
				gint64 _tmp68_;
				gchar* _tmp69_;
				gchar* _tmp70_;
				gchar* _tmp71_;
				_tmp65_ = seconds;
				days = _tmp65_ / 86400;
				_tmp66_ = info;
				_tmp67_ = days;
				_tmp68_ = days;
				_tmp69_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld day until empty", "%lld days until empty", (gulong) _tmp67_), _tmp68_);
				_tmp70_ = _tmp69_;
				_tmp71_ = g_strconcat (_tmp66_, _tmp70_, NULL);
				_g_free0 (info);
				info = _tmp71_;
				_g_free0 (_tmp70_);
			} else {
				gint64 _tmp72_;
				_tmp72_ = seconds;
				if (_tmp72_ >= ((gint64) 3600)) {
					gint64 hours = 0LL;
					gint64 _tmp73_;
					const gchar* _tmp74_;
					gint64 _tmp75_;
					gint64 _tmp76_;
					gchar* _tmp77_;
					gchar* _tmp78_;
					gchar* _tmp79_;
					_tmp73_ = seconds;
					hours = _tmp73_ / 3600;
					_tmp74_ = info;
					_tmp75_ = hours;
					_tmp76_ = hours;
					_tmp77_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld hour until empty", "%lld hours until empty", (gulong) _tmp75_), _tmp76_);
					_tmp78_ = _tmp77_;
					_tmp79_ = g_strconcat (_tmp74_, _tmp78_, NULL);
					_g_free0 (info);
					info = _tmp79_;
					_g_free0 (_tmp78_);
				} else {
					gint64 _tmp80_;
					_tmp80_ = seconds;
					if (_tmp80_ >= ((gint64) 60)) {
						gint64 minutes = 0LL;
						gint64 _tmp81_;
						const gchar* _tmp82_;
						gint64 _tmp83_;
						gint64 _tmp84_;
						gchar* _tmp85_;
						gchar* _tmp86_;
						gchar* _tmp87_;
						_tmp81_ = seconds;
						minutes = _tmp81_ / 60;
						_tmp82_ = info;
						_tmp83_ = minutes;
						_tmp84_ = minutes;
						_tmp85_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld minute until empty", "%lld minutes until empty", (gulong) _tmp83_), _tmp84_);
						_tmp86_ = _tmp85_;
						_tmp87_ = g_strconcat (_tmp82_, _tmp86_, NULL);
						_g_free0 (info);
						info = _tmp87_;
						_g_free0 (_tmp86_);
					} else {
						const gchar* _tmp88_;
						gint64 _tmp89_;
						gint64 _tmp90_;
						gchar* _tmp91_;
						gchar* _tmp92_;
						gchar* _tmp93_;
						_tmp88_ = info;
						_tmp89_ = seconds;
						_tmp90_ = seconds;
						_tmp91_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld second until empty", "%lld seconds until empty", (gulong) _tmp89_), _tmp90_);
						_tmp92_ = _tmp91_;
						_tmp93_ = g_strconcat (_tmp88_, _tmp92_, NULL);
						_g_free0 (info);
						info = _tmp93_;
						_g_free0 (_tmp92_);
					}
				}
			}
		}
	}
	result = info;
	return result;
}


void power_utils_translations (void) {
	ngettext ("%lld day until full", "%lld days until full", (gulong) 0);
	ngettext ("%lld hour until full", "%lld hours until full", (gulong) 0);
	ngettext ("%lld minute until full", "%lld minutes until full", (gulong) 0);
	ngettext ("%lld second until full", "%lld seconds until full", (gulong) 0);
	ngettext ("%lld day until empty", "%lld days until empty", (gulong) 0);
	ngettext ("%lld hour until empty", "%lld hours until empty", (gulong) 0);
	ngettext ("%lld minute until empty", "%lld minutes until empty", (gulong) 0);
	ngettext ("%lld second until empty", "%lld seconds until empty", (gulong) 0);
}



